<?php

/*
 * @author Adam Westerski 
 * @file ideastream_services.inc
 * ideastream Module
 */
 
/*
 * New mappings for RDFme
 */
function _ideastream_rdfme_services() {
	//Service 1: Generate IdeaStream Statistics
	$services['ideastream_stats']['name'] = 'ideastream_stats';
	$services['ideastream_stats']['type'] = 'sparqlscript';
	$services['ideastream_stats']['param']['@@@dataset.url@@@'] = url('tordf',array('absolute' => TRUE)); //setup service for local rdfme dump
	$services['ideastream_stats']['param']['@@@ims.name@@@'] = variable_get('site_name', "IdeaStream Stats"); //check the name of the current IdeaStream / drupal installation
	$services['ideastream_stats']['query']= '  #current data count
  $idea_count = SELECT COUNT(?idea_uri) AS ?idea_count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?idea_uri a <http://purl.org/gi2mo/ns#Idea> . 
   }
  }
  
  $comment_count = SELECT COUNT(?comment_uri) AS ?comment_count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?comment_uri a <http://purl.org/gi2mo/ns#Comment> .
   }
  }
  
  $review_count = SELECT COUNT(?review_uri) AS ?review_count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?review_uri a <http://purl.org/gi2mo/ns#Review> .
   }
  }
  
  $contest_count = SELECT COUNT(?contest_uri) AS ?contest_count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?contest_uri a <http://purl.org/gi2mo/ns#IdeaContest> .
   }
  }
  
  #last day count
  $idea_count_last_day = SELECT COUNT(?idea_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?idea_uri a <http://purl.org/gi2mo/ns#Idea> . 
    ?idea_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1d}")
   }
  }
  
  $comment_count_last_day = SELECT COUNT(?comment_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?comment_uri a <http://purl.org/gi2mo/ns#Comment> .
    ?comment_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1d}")
   }
  }
  
  $review_count_last_day = SELECT COUNT(?review_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?review_uri a <http://purl.org/gi2mo/ns#Review> .
    ?review_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1d}")
   }
  }
  
  $contest_count_last_day = SELECT COUNT(?contest_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?contest_uri a <http://purl.org/gi2mo/ns#IdeaContest> .
    ?contest_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1d}")
   }
  }
  
  #last week count
  $idea_count_last_week = SELECT COUNT(?idea_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?idea_uri a <http://purl.org/gi2mo/ns#Idea> . 
    ?idea_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 7d}")
   }
  }
  
  $comment_count_last_week = SELECT COUNT(?comment_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?comment_uri a <http://purl.org/gi2mo/ns#Comment> .
    ?comment_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 7d}")
   }
  }
  
  $review_count_last_week = SELECT COUNT(?review_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?review_uri a <http://purl.org/gi2mo/ns#Review> .
    ?review_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 7d}")
   }
  }
  
  $contest_count_last_week = SELECT COUNT(?contest_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?contest_uri a <http://purl.org/gi2mo/ns#IdeaContest> .
    ?contest_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 7d}")
   }
  }
  
  #last month count
  $idea_count_last_month = SELECT COUNT(?idea_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?idea_uri a <http://purl.org/gi2mo/ns#Idea> . 
    ?idea_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1mo}")
   }
  }
  
  $comment_count_last_month = SELECT COUNT(?comment_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?comment_uri a <http://purl.org/gi2mo/ns#Comment> .
    ?comment_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1mo}")
   }
  }
  
  $review_count_last_month = SELECT COUNT(?review_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?review_uri a <http://purl.org/gi2mo/ns#Review> .
    ?review_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1mo}")
   }
  }
  
  $contest_count_last_month = SELECT COUNT(?contest_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?contest_uri a <http://purl.org/gi2mo/ns#IdeaContest> .
    ?contest_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1mo}")
   }
  }
  
  #last year count
  $idea_count_last_year = SELECT COUNT(?idea_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?idea_uri a <http://purl.org/gi2mo/ns#Idea> . 
    ?idea_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1y}")
   }
  }
  
  $comment_count_last_year = SELECT COUNT(?comment_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?comment_uri a <http://purl.org/gi2mo/ns#Comment> .
    ?comment_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1y}")
   }
  }
  
  $review_count_last_year = SELECT COUNT(?review_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?review_uri a <http://purl.org/gi2mo/ns#Review> .
    ?review_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1y}")
   }
  }
  
  $contest_count_last_year = SELECT COUNT(?contest_uri) AS ?count WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?contest_uri a <http://purl.org/gi2mo/ns#IdeaContest> .
    ?contest_uri <http://purl.org/dc/terms/created> ?created .
    FILTER (?created > "${NOW - 1y}")
   }
  }
  
  #last idea
  
  $last_idea = SELECT ?idea_uri ?title ?content ?author_uri ?author_acc_name WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?idea_uri a <http://purl.org/gi2mo/ns#Idea> . 
    ?idea_uri <http://purl.org/dc/terms/title> ?title .
    ?idea_uri <http://purl.org/gi2mo/ns#content> ?content .
    ?idea_uri <http://purl.org/dc/terms/created> ?created .
    ?idea_uri <http://purl.org/gi2mo/ns#hasCreator> ?author_uri .
    ?author_uri a <http://purl.org/gi2mo/ns#User> . 
    ?author_uri <http://xmlns.com/foaf/0.1/accountName> ?author_acc_name .
    }
   } ORDER BY DESC(?created)
  LIMIT 1
  
  $ims_has_idea = "<@@@dataset.url@@@> a gi2mo:IdeaManagementSystem"
  
  IF ($last_idea) {
  $ims_has_idea = "<@@@dataset.url@@@> gi2mo:hasIdea <${last_idea.0.idea_uri}>" }
  
  #last comment
  
  $last_comment = SELECT ?comment_uri ?title ?content ?author_uri ?author_acc_name WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?comment_uri a <http://purl.org/gi2mo/ns#Comment> . 
    ?comment_uri <http://purl.org/dc/terms/title> ?title .
    ?comment_uri <http://purl.org/gi2mo/ns#content> ?content .
    ?comment_uri <http://purl.org/dc/terms/created> ?created .
    ?comment_uri <http://purl.org/gi2mo/ns#hasCreator> ?author_uri .
    ?author_uri a <http://purl.org/gi2mo/ns#User> . 
    ?author_uri <http://xmlns.com/foaf/0.1/accountName> ?author_acc_name .
    }
   } ORDER BY DESC(?created)
  LIMIT 1
    
  $ims_has_comment = "<@@@dataset.url@@@> a gi2mo:IdeaManagementSystem"
  
  IF ($last_comment) {
  $ims_has_comment = "<@@@dataset.url@@@> gi2mo:hasComment <${last_comment.0.comment_uri}>" }
  
  #last contest
  
  $last_contest = SELECT ?contest_uri ?title ?content ?author_uri ?author_acc_name WHERE {
   GRAPH <@@@dataset.url@@@> { 
    ?contest_uri a <http://purl.org/gi2mo/ns#IdeaContest> . 
    ?contest_uri <http://purl.org/dc/terms/title> ?title .
    ?contest_uri <http://purl.org/gi2mo/ns#content> ?content .
    ?contest_uri <http://purl.org/dc/terms/created> ?created .
    ?contest_uri <http://purl.org/gi2mo/ns#hasCreator> ?author_uri .
    ?author_uri a <http://purl.org/gi2mo/ns#User> . 
    ?author_uri <http://xmlns.com/foaf/0.1/accountName> ?author_acc_name .
    }
   } ORDER BY DESC(?created)
  LIMIT 1
  
  $ims_has_contest = "<@@@dataset.url@@@> a gi2mo:IdeaManagementSystem"
  
  IF ($last_contest) {
  $ims_has_contest = "<@@@dataset.url@@@> gi2mo:hasIdeaContest <${last_contest.0.contest_uri}>" }
  
  #ims stats
  PREFIX gi2mo: <http://purl.org/gi2mo/ns#>
  PREFIX dcterms:  <http://purl.org/dc/terms/>
  PREFIX foaf:  <http://xmlns.com/foaf/0.1/>
  PREFIX ideastream:  <http://purl.org/gi2mo/ideastream/ns#>
  $res = CONSTRUCT { 
     <@@@dataset.url@@@> a gi2mo:IdeaManagementSystem .
     <@@@dataset.url@@@> dcterms:title "@@@ims.name@@@".
     <@@@dataset.url@@@> ideastream:ideaCount "${idea_count.0.idea_count}".
     <@@@dataset.url@@@> ideastream:commentCount "${comment_count.0.comment_count}".
     <@@@dataset.url@@@> ideastream:contestCount "${contest_count.0.contest_count}".
     <@@@dataset.url@@@> ideastream:reviewCount "${review_count.0.review_count}".
     
     <@@@dataset.url@@@> ideastream:ideaCountLastDay "${idea_count_last_day.0.count}".
     <@@@dataset.url@@@> ideastream:commentCountLastDay "${comment_count_last_day.0.count}".
     <@@@dataset.url@@@> ideastream:contestCountLastDay "${contest_count_last_day.0.count}".
     <@@@dataset.url@@@> ideastream:reviewCountLastDay "${review_count_last_day.0.count}".
     
     <@@@dataset.url@@@> ideastream:ideaCountLastWeek "${idea_count_last_week.0.count}".
     <@@@dataset.url@@@> ideastream:commentCountLastWeek "${comment_count_last_week.0.count}".
     <@@@dataset.url@@@> ideastream:contestCountLastWeek "${contest_count_last_week.0.count}".
     <@@@dataset.url@@@> ideastream:reviewCountLastWeek "${review_count_last_week.0.count}".
     
     <@@@dataset.url@@@> ideastream:ideaCountLastMonth "${idea_count_last_month.0.count}".
     <@@@dataset.url@@@> ideastream:commentCountLastMonth "${comment_count_last_month.0.count}".
     <@@@dataset.url@@@> ideastream:contestCountLastMonth "${contest_count_last_month.0.count}".
     <@@@dataset.url@@@> ideastream:reviewCountLastMonth "${review_count_last_month.0.count}".
     
     <@@@dataset.url@@@> ideastream:ideaCountLastYear "${idea_count_last_year.0.count}".
     <@@@dataset.url@@@> ideastream:commentCountLastYear "${comment_count_last_year.0.count}".
     <@@@dataset.url@@@> ideastream:contestCountLastYear "${contest_count_last_year.0.count}".
     <@@@dataset.url@@@> ideastream:reviewCountLastYear "${review_count_last_year.0.count}".
     ${ims_has_idea} .
     ${ims_has_comment} .
     ${ims_has_contest} .     
 	} WHERE {

   }
   
   $res2 = CONSTRUCT { 
     <${last_idea.0.idea_uri}> a gi2mo:Idea .
     <${last_idea.0.idea_uri}> dcterms:title "${last_idea.0.title}" .
     <${last_idea.0.idea_uri}> gi2mo:content "${last_idea.0.content}" .
     <${last_idea.0.idea_uri}> gi2mo:hasCreator <${last_idea.0.author_uri}> .
     
     <${last_idea.0.author_uri}> a gi2mo:User .
     <${last_idea.0.author_uri}> foaf:accountName "${last_idea.0.author_acc_name}" .
 	} WHERE {
	?contest_uri a gi2mo:Idea .
   }
   
   $res3 = CONSTRUCT { 
     <${last_comment.0.comment_uri}> a gi2mo:Comment .
     <${last_comment.0.comment_uri}> dcterms:title "${last_comment.0.title}" .
     <${last_comment.0.comment_uri}> gi2mo:content "${last_comment.0.content}" .
     <${last_comment.0.comment_uri}> gi2mo:hasCreator <${last_comment.0.author_uri}> .
     
     <${last_comment.0.author_uri}> a gi2mo:User .
     <${last_comment.0.author_uri}> foaf:accountName "${last_comment.0.author_acc_name}" .
 	} WHERE {
	?contest_uri a gi2mo:Comment .
   }
   
   $res4 = CONSTRUCT { 
     <${last_contest.0.contest_uri}> a gi2mo:IdeaContest .
     <${last_contest.0.contest_uri}> dcterms:title "${last_contest.0.title}" .
     <${last_contest.0.contest_uri}> gi2mo:content "${last_contest.0.content}" .
     <${last_contest.0.contest_uri}> gi2mo:hasCreator <${last_contest.0.author_uri}> .
     
     <${last_contest.0.author_uri}> a gi2mo:User .
     <${last_contest.0.author_uri}> foaf:accountName "${last_contest.0.author_acc_name}" .
 	} WHERE {
	?contest_uri a gi2mo:IdeaContest .
   }
   
   $time = ${NOW -1mo}
   $rdfme_service = $res + $res2
   $rdfme_service = $rdfme_service + $res3
   $rdfme_service = $rdfme_service + $res4';
	
	
	//Service 2: Fetch 10 latest ideas 
	$services['get_all']['name'] = 'get_latest_idea_names';
	$services['get_all']['type'] = 'sparql';
	$services['get_all']['param']['@@@dataset.url@@@'] = url('tordf',array('absolute' => TRUE)); //setup service for local rdfme dump
	$services['get_all']['query'] = 'PREFIX gi2mo: <http://purl.org/gi2mo/ns#> .  
PREFIX dcterms:  <http://purl.org/dc/terms/> .
SELECT ?idea_title ?idea_date WHERE {
  GRAPH <@@@dataset.url@@@> { 
    ?idea_uri a gi2mo:Idea . 
    ?idea_uri dcterms:title ?idea_title . 
    ?idea_uri dcterms:created ?idea_date . 
   }
}
ORDER BY DESC(?idea_date)
LIMIT 10';
	return $services;
}

?>