<?php

// $Id$

/**
 * @file
 * RDFme module.
 * Author: Fernando Tapia Rico, Adam Westerski
 * File: rdfme.endpoint.inc
 * Version: 1.7
 */
 
/**
 * Add dataset action
 */
function rdfme_add_dataset($dataset_url, $dataset_name, $dataset_type) {
  
 $datasets = db_fetch_object(db_query("SELECT * FROM {rdfme_endpoint} WHERE url = '%s'", $dataset_url));

  if (!$datasets) {
    db_query("INSERT INTO {rdfme_endpoint} (name, url, type, last_update) VALUES ('%s', '%s', '%s', NOW())", $dataset_name, $dataset_url, $dataset_type);
    //add the triples to ARC2 store
	$result= rdfme_arc2_index_graph($dataset_url,$dataset_type);
	if ($result)
		drupal_set_message(t('The dataset for "!name" has been created.', array('!name' => $dataset_name)));
	else
		drupal_set_message(t('Error adding triples of dataset with name: !name', array('!name' => $dataset_name)), 'error'); 
  }
  elseif ($datasets->name != $ns) {
    db_query("UPDATE {rdfme_endpoint} SET name = '%s' WHERE url = '%s'", $dataset_name, $dataset_url);
    drupal_set_message(t('The dataset name has been updated.'));
  }
  else {
    drupal_set_message(t('Dataset already in the system.'));
  }
}

/**
 * Add service action
 */
function rdfme_add_service($service_name, $service_query, $service_type) {
  
 $datasets = db_fetch_object(db_query("SELECT * FROM {rdfme_endpoint_services} WHERE name = '%s'", $dataset_url));

  if (!$datasets) {
    db_query("INSERT INTO {rdfme_endpoint_services} (name, url, query, type, last_update, status) VALUES ('%s', '%s', '%s', '%s', NOW(), 1)", $service_name, NULL, $service_query,$service_type);
	drupal_set_message(t('The service for "!name" has been created.', array('!name' => $service_name)));
  }
  else {
    drupal_set_message(t('Service already in the system, choose a different name.'));
  }
}

/**
 * Update service action
 */
function rdfme_update_service($service_id, $service_name, $service_query, $service_type) {
  
 //$datasets = db_fetch_object(db_query(db_rewrite_sql("SELECT * FROM {rdfme_endpoint_services} WHERE name = '%s'"), $dataset_url));

  //if (!$datasets) {
//      db_query("UPDATE {rdfme_namespaces} SET uri = '%s' WHERE prefix = '%s'", $ns, $prefix);
    db_query("UPDATE {rdfme_endpoint_services} SET name='%s', query='%s' , type='%s', last_update=NOW() WHERE id = '%d'", $service_name, $service_query,$service_type, $service_id);
	drupal_set_message(t('The service for "!name" has been updated.', array('!name' => $service_name)));
 // }
 // else {
 //   drupal_set_message(t('Service already in the system, choose a different name.'));
 // }
}

/**
 * ***************       RDFme       ***************
 * *************** Endpoint Datasets ***************
 */

/**
 * This function creates the form to update RDF datasets
 */
function rdfme_admin_endpoint() {
  $form['add'] = array(
    '#type' => 'fieldset',
    '#title' => t('Add dataset'),
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
    '#tree' => FALSE,
    '#description' => t('RDFme allows to setup a query endpoint to search through the RDF metadata that it creates. The query endpoint supports !sparql language but before queries can be made the data has to be indexed. In order to keep the data up to date use !cron just like with regular Drupal search index. In addition to the data produced by the local instance it is possible to index data from external RDF files (for example other Drupal instances that have installed RDFme).',
      array(
        '!RDF' => l(t('RDF'), 'http://drupal.org/project/rdf'),
        '!indexed' => l(t('indexed'), 'http://github.com/semsol/arc2'),
        '!sparql' => l('SPARQL', 'http://www.w3.org/TR/rdf-sparql-query/'),
        '!cron' => l('cron maintenance task', 'admin/reports/status'),
      )
    ),
  );
  $form['add']['name'] = array(
    '#type' => 'textfield',
    '#size' => 20,
    '#maxlength' => 40,
  );
  $form['add']['url'] = array(
    '#type' => 'textfield',
    '#size' => 53,
    '#maxlength' => 100,
  );
  $form['add']['type'] = array(
    '#type' => 'select',
    '#default_value' => 'normal',
    '#options' => array(
     'normal' => t('Normal'), 
	 'local' => t('Local'), 
     'rdfme' => t('RDFme'), 
     'file' => t('File'),
    ),
  );
  $form['add']['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Add source',
  );
  $form['list'] = array(
    '#type' => 'fieldset',
    '#title' => t('Datasets'),
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
    '#tree' => FALSE,
    '#description' => t('The datasets are automatically indexed when added but they are not kept in sync unless cron task is enabled. Optionally you can manually !update or !reindex.', array('!update' => l('invoke update for entire index', 'admin/settings/rdfme/endpoint/update/all'), '!reindex' => l('invoke reindex (force delete all and index again)', 'admin/settings/rdfme/endpoint/reindex/all')))
  );
  return $form;
}

function theme_rdfme_admin_endpoint($form) {
  $rows = array();
  $rows[] = array(drupal_render($form['add']['name']), drupal_render($form['add']['url']), drupal_render($form['add']['type']));
  $header = array(t('Dataset Name'), t('Source URL'), t('Indexing'));
  $form['add']['#value'] = theme('table', $header, $rows) . drupal_render($form['add']['submit']);
//  unset($form['add']['sparql_endpoint']);
  unset($form['add']['name']);
  unset($form['add']['url']);
  unset($form['add']['type']);
  unset($form['add']['submit']);
  $namespaces = db_query("SELECT * FROM {rdfme_endpoint} ORDER BY id");
  $rows = array();
  $header = array(t('Dataset&nbspName'), t('Source&nbspURL'), t('Operations'));
  while ($item = db_fetch_object($namespaces)) {
    $rows[] = array(
      $item->name." <span style='color: green'>(".$item->type.")</span>",
      check_plain($item->url),
      l(t('Delete'), 'admin/settings/rdfme/endpoint/delete/' . $item->id)."&nbsp|&nbsp".l(t('Update'), 'admin/settings/rdfme/endpoint/update/' . $item->id) ,
    );
  }
  $form['list']['#value'] = theme('table', $header, $rows) . l(t('Delete all datasets'), 'admin/settings/rdfme/endpoint/deleteall') . "&nbsp|&nbsp" . l(t('Reindex all datasets'), 'admin/settings/rdfme/endpoint/reindex/all') . "&nbsp|&nbsp" . l(t('Update all datasets'), 'admin/settings/rdfme/endpoint/update/all');
  return drupal_render($form);
}

function rdfme_admin_endpoint_submit($form, &$form_state) {
  if ($form_state['values']['url'] != '' &&  $form_state['values']['name'] != '') {
    rdfme_add_dataset($form_state['values']['url'], $form_state['values']['name'], $form_state['values']['type']);
  }
  else {
    drupal_set_message(t('Dataset name and URL cannot be blank fields'));
  }
  // Redirect to the rdfme module settings
  $form_state['redirect'] = 'admin/settings/rdfme/endpoint';
}

/**
 * Delete dataset
 * @param id of the dataset to delete
 */
function rdfme_delete_dataset($id) {
  // delete the triples from the ARC2 store
  $dataset = db_fetch_object(db_query("SELECT * FROM {rdfme_endpoint} WHERE id = '%d'", $id));
  
  if (!$dataset) { //if there was no dataset in the database show error
  	drupal_set_message(t('Error deleting the dataset (dataset not found in the RDFme database). Please, try again.'),'error');
  } else
  {
  	  $result= rdfme_arc2_delete_graph($dataset->url);
  	  if (!$result)
	  { //if deleting triples from ARC2 was unsuccessful show error
	  		drupal_set_message(t('Error deleting the dataset (triple store error). Please, try again.'),'error');
	  } else
	  {
		  $exe_query = db_query("DELETE FROM {rdfme_endpoint} WHERE id = '%d'", $id);
		  if ($exe_query != FALSE) {
		    drupal_set_message(t('Deleted dataset with id: !id', array('!id' => $id)));
		  }
		  else {
		    drupal_set_message(t('Error deleting the dataset (error deleting from RDFme database). Please, try again.'),'error');
		  }
	  }
  }
  // Redirect to the rdfme module settings
  drupal_goto('admin/settings/rdfme/endpoint');
}


/**
 * Delete all datasets
 */
function rdfme_delete_all_datasets() {
  // Datasets
  $exe_query = db_query("DELETE FROM {rdfme_endpoint}");
  if ($exe_query !== FALSE) {
  	rdfme_arc2_delete_all(); //clean triple store 
    drupal_set_message(t('Datasets deleted'));
  }
  else {
    drupal_set_message(t('Error deleting datasets. Please, try again.'));
  }
  // Redirect to the rdfme module settings
  drupal_goto('admin/settings/rdfme/endpoint');
}

/**
 * Update index for a dataset
 */
function rdfme_update_index_dataset($id) {
  if ($id == 'all')  //reindex all datasets
  {
  	$dataset_infos = db_query("SELECT * FROM {rdfme_endpoint}");
  	while ($dataset_info = db_fetch_object($dataset_infos)) {
		if (!$dataset_info) {
		    drupal_set_message(t('Error dataset data does not exist in the database, remove and add the datasets again!'));
	  	}
		  else {
		  	$result= rdfme_arc2_update_graph($dataset_info->url, $dataset_info->type, $dataset_info->last_update);
		  	if ($result)
		  	{
		  		//if reindex success change index update date in the RDFme database
		  		$update_result = db_query("UPDATE rdfme_endpoint SET last_update=NOW() WHERE id='%d'",$dataset_info->id);
		  		drupal_set_message(t('Updated dataset with name: !name', array('!name' => $dataset_info->name))); 
		  	}
		  	else
		  		drupal_set_message(t('Error reindexing dataset with name: !name', array('!name' => $dataset_info->name)), 'error'); 
		}  	
  	}
  	drupal_set_message(t('Reindexed all datasets.'));
  } else //reindex only one dataset with particular id
  {
  	//get dataset url
	$dataset = db_fetch_object(db_query("SELECT * FROM {rdfme_endpoint} WHERE id = '%d'", $id));

	if (!$dataset) {
	    drupal_set_message(t('Error dataset data does not exist in the database, remove and add the datasets again!'));
  	}
	  else {
	  	$result= rdfme_arc2_update_graph($dataset->url, $dataset->type, $dataset->last_update);
	  	if ($result) {
	  		//if reindex success change index update date in the RDFme database
	  		$update_result = db_query("UPDATE rdfme_endpoint SET last_update=NOW() WHERE id='%d'", $id);
	  		drupal_set_message(t('Updated dataset with id: !id', array('!id' => $id))); 
	  	}
	  	else
	  		drupal_set_message(t('Error reindexing dataset with id: !id', array('!id' => $id)), 'error'); 
	}
  }
  // Redirect to the rdfme module settings
  drupal_goto('admin/settings/rdfme/endpoint');
}

/**
 * Reindex dataset (remove old data and put everything again)
 */
function rdfme_reindex_dataset($id) {
  if ($id == 'all')  //reindex all datasets
  {
  	$dataset_infos = db_query("SELECT * FROM {rdfme_endpoint}");
  	while ($dataset_info = db_fetch_object($dataset_infos)) {
		if (!$dataset_info) {
		    drupal_set_message(t('Error dataset data does not exist in the database, remove and add the datasets again!'));
	  	}
		  else {
		  	$result= rdfme_arc2_index_graph($dataset_info->url, $dataset_info->type);
		  	if ($result)
		  	{
		  		//if reindex success change index update date in the RDFme database
		  		$update_result = db_query("UPDATE rdfme_endpoint SET last_update=NOW() WHERE id='%d'",$dataset_info->id);
		  		drupal_set_message(t('Reindexed dataset with name: !name', array('!name' => $dataset_info->name))); 
		  	}
		  	else
		  		drupal_set_message(t('Error reindexing dataset with name: !name', array('!name' => $dataset_info->name)), 'error'); 
		}  	
  	}
  	drupal_set_message(t('Reindexed all datasets.'));
  } else //reindex only one dataset with particular id
  {
  	//get dataset url
	$dataset = db_fetch_object(db_query("SELECT * FROM {rdfme_endpoint} WHERE id = '%d'", $id));

	if (!$dataset) {
	    drupal_set_message(t('Error dataset data does not exist in the database, remove and add the datasets again!'));
  	}
	  else {
	  	$result= rdfme_arc2_index_graph($dataset->url, $dataset->type);
	  	if ($result) {
	  		//if reindex success change index update date in the RDFme database
	  		$update_result = db_query("UPDATE rdfme_endpoint SET last_update=NOW() WHERE id='%d'", $id);
	  		drupal_set_message(t('Reindexed dataset with id: !id', array('!id' => $id))); 
	  	}
	  	else
	  		drupal_set_message(t('Error reindexing dataset with id: !id', array('!id' => $id)), 'error'); 
	}
  }
  // Redirect to the rdfme module settings
  drupal_goto('admin/settings/rdfme/endpoint');
}

/**
 * ***************       RDFme       ***************
 * *************** Endpoint Options  ***************
 */

/**
 * This function creates the form to update RDFme Endpoint settings
 */
function rdfme_admin_endpoint_settings() {
  $form['settings'] = array(
    '#type' => 'fieldset',
    '#title' => t('RDFme Endpoint Settings'),
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
    '#tree' => FALSE,
    '#description' => t('RDFme allows to setup a query endpoint to search through the RDF metadata that it creates. The query endpoint supports !sparql language but before queries can be made the data has to be indexed. In order to keep the data up to date use !cron just like with regular Drupal search index. In addition to the data produced by the local instance it is possible to index data from external RDF files (for example other Drupal instances that have installed RDFme).',
      array(
        '!RDF' => l(t('RDF'), 'http://drupal.org/project/rdf'),
        '!indexed' => l(t('indexed'), 'http://github.com/semsol/arc2'),
        '!sparql' => l('SPARQL', 'http://www.w3.org/TR/rdf-sparql-query/'),
        '!cron' => l('cron maintenance task', 'admin/reports/status'),
      )
    ),
  );
  $form['settings']['sparql_query'] = array(
    '#type' => 'radios',
	'#title' => t('SPARQL query Endpoint'),
    '#description' => t('Apart of the custom services based on SPARQL queries, the RDFme Data Endpoint allows to give full access to the indexed data. You can enable or disable that service. Additionally, access to read/ write operations of the endpoint can be configured with Drupal User Permissions. The Generic SPARQL endpoint is available under !endpoint.',
      array(
        '!endpoint' => l(t('rdfme/endpoint'), 'rdfme/endpoint/'),
      )),
	'#default_value' => variable_get('rdfme_endpoint_sparql_status', 0),
	'#options' => array(t('Disabled'), t('Enabled')),
  );
    
  $form['settings']['cron'] = array(
    '#type' => 'checkbox',
    '#description' => t('The data available in the endpoint is separate to the underlying relational database (e.g. MySQL). In order to keep your data up-to-date it needs to be reindexed just like with the Drupal search index. You can enable or disable indexing with regular Drupal CRON cycles.'),
    '#title' => t('Automatically update index during CRON cycles.'),
    '#default_value' => variable_get('rdfme_endpoint_cron_status', 0),
  );  
  $form['settings']['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Save',
  );
  return $form;
}

function theme_rdfme_admin_endpoint_settings($form) {
  $rows = array();
  $rows[] = array(drupal_render($form['add']['name']), drupal_render($form['add']['url']), drupal_render($form['add']['type']));
  $header = array(t('Dataset Name'), t('Source URL'), t('Indexing'));
  $form['add']['#value'] = theme('table', $header, $rows) . drupal_render($form['add']['submit']);
//  unset($form['add']['sparql_endpoint']);
  unset($form['add']['name']);
  unset($form['add']['url']);
  unset($form['add']['type']);
  unset($form['add']['submit']);
  $namespaces = db_query("SELECT * FROM {rdfme_endpoint} ORDER BY id");
  $rows = array();
  $header = array(t('Dataset&nbspName'), t('Source&nbspURL'), t('Operations'));
  while ($item = db_fetch_object($namespaces)) {
    $rows[] = array(
      $item->name." <span style='color: green'>(".$item->type.")</span>",
      check_plain($item->url),
      l(t('Delete'), 'admin/settings/rdfme/endpoint/delete/' . $item->id)."&nbsp|&nbsp".l(t('Reindex'), 'admin/settings/rdfme/endpoint/reindex/' . $item->id) ,
    );
  }
  $form['list']['#value'] = theme('table', $header, $rows) . l(t('Delete all datasets'), 'admin/settings/rdfme/endpoint/deleteall');
  return drupal_render($form);
}

function rdfme_admin_endpoint_settings_submit($form, &$form_state) {
    variable_set('rdfme_endpoint_sparql_status', $form_state['values']['sparql_query']);
  	variable_set('rdfme_endpoint_cron_status', $form_state['values']['cron']);
  
  drupal_set_message(t('Settings Saved'));
  // Redirect to the rdfme module settings
  $form_state['redirect'] = 'admin/settings/rdfme/endpoint/options';
}

/**
 * ***************       RDFme       ***************
 * *************** Endpoint Services ***************
 */

/**
 * This function creates the form to update RDFme Endpoint Services
 */
function rdfme_admin_endpoint_services() {
  $form['services'] = array(
    '#type' => 'fieldset',
    '#title' => t('Add new SPARQL Service'),
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
    '#tree' => FALSE,
    '#description' => t('RDFme allows to create custom services that operate on Endpoint data and are based on SPARQL and SPARQLScript functionality of the underlying ARC2 triple store. The services can retrieve or write data and return a certain response to the client. For example: get 10 last nodes of particular kind, get 10 last comments, get statistics of the drupal etc. If SPARQLScript is used the final result should be put into "rdfme_service" variable).',
      array(
        '!RDF' => l(t('RDF'), 'http://drupal.org/project/rdf'),
        '!indexed' => l(t('indexed'), 'http://github.com/semsol/arc2'),
        '!sparql' => l('SPARQL', 'http://www.w3.org/TR/rdf-sparql-query/'),
        '!cron' => l('cron maintenance task', 'admin/reports/status'),
      )
    ),
  );
  $form['services']['service_name'] = array(
    '#type' => 'textfield',
    '#title' => t('Service name'),
    '#description' => t('Name used in the HTTP address of the service to access it.'),
  );
  $form['services']['service_query'] = array(
    '#type' => 'textarea',
	'#title' => t('Service query text'),
    '#description' => t('Service query text is a script in SPARQL or SPARQLScript that operates on the datasets and returns some response to the client.', array('!reindex' => l('invoke update for entire index', 'admin/settings/rdfme/endpoint/reindex/all'))),
  );
  
  $sparql_filter_id = rdfme_check_sparql_code_editor();
  if ($sparql_filter_id)
  	$form['services']['format'] = filter_form($sparql_filter_id, NULL, array('service_query_format'));
    
  $form['services']['sparqlscript'] = array(
    '#type' => 'checkbox',
    '#description' => t('SPARQLScript is an extension to SPARQL that allows variables and simple operators like loops and conditional statements, much like scripting in relational databases. For details see SPARQLScript manual.'),
    '#title' => t('SPARQLScript Service'),
  );
  $form['services']['submit'] = array(
    '#type' => 'submit',
    '#value' => 'Save Service',
  );
  $form['services_list'] = array(
    '#type' => 'fieldset',
    '#title' => t('Services'),
    '#collapsible' => FALSE,
    '#collapsed' => FALSE,
    '#tree' => FALSE,
    '#description' => t('All the services are available under &lt;drupal address&gt;/rdfme/service?=&lt;service_name&gt;', array('!reindex' => l('invoke update for entire index', 'admin/settings/rdfme/endpoint/reindex/all')))
  );
  return $form;
}

function theme_rdfme_admin_endpoint_services($form) {
  /*
  $rows = array();
  $rows[] = array(drupal_render($form['add']['name']), drupal_render($form['add']['url']), drupal_render($form['add']['type']));
  $header = array(t('Dataset Name'), t('Source URL'), t('Indexing'));
  $form['add']['#value'] = theme('table', $header, $rows) . drupal_render($form['add']['submit']);
//  unset($form['add']['sparql_endpoint']);
  unset($form['add']['name']);
  unset($form['add']['url']);
  unset($form['add']['type']);
  unset($form['add']['submit']); */
  $status_operation = array('0'=> 'Enable', '1'=>'Disable'); //
  $status_color = array('1'=> 'green', '0'=>'gray');
  $name_color = array('1'=> 'default', '0'=>'gray');

  $namespaces = db_query("SELECT * FROM {rdfme_endpoint_services} ORDER BY id");
  $rows = array();
  $header = array(t('Service&nbspName'), t('Modified'), t('Operations'));
  while ($item = db_fetch_object($namespaces)) {
    $rows[] = array(
      "<span style='color:".$name_color[$item->status]."'>".$item->name."</span>"." <span style='color:".$status_color[$item->status]."'>(".$item->type.")</span>",
      "<span style='color:".$name_color[$item->status]."'>".$item->last_update."</span>",
      l(t($status_operation[$item->status]), 'admin/settings/rdfme/endpoint/services/' . strtolower($status_operation[$item->status]) .'/'. $item->name) . "&nbsp|&nbsp" . l(t('Delete'), 'admin/settings/rdfme/endpoint/services/delete/' . $item->id)."&nbsp|&nbsp".l(t('Edit'), 'admin/settings/rdfme/endpoint/services/edit/' . $item->name)."&nbsp|&nbsp".l(t('Invoke'), 'rdfme/' . $item->name));
  }
  $form['services_list']['#value'] = theme('table', $header, $rows) . l(t('Delete all services'), 'admin/settings/rdfme/endpoint/services/deleteall');
  return drupal_render($form);
}

function rdfme_admin_endpoint_services_submit($form, &$form_state) {
  if ($form_state['values']['service_name'] != '' &&  $form_state['values']['service_query'] != '') {
  	$service_type = "sparql";
  	if ($form_state['values']['sparqlscript'] == 1) $service_type = "sparqlscript";
    rdfme_add_service($form_state['values']['service_name'], $form_state['values']['service_query'], $service_type);
  }
  else {
    drupal_set_message(t('Service name and query cannot be blank fields'));
  }
  // Redirect to the rdfme module settings
  $form_state['redirect'] = 'admin/settings/rdfme/endpoint/services';
}

/**
 * Invoke service
 * @param name of the service to invoke
 */
function rdfme_invoke_service($name) {
  drupal_set_header('Content-Type: rdf/xml; charset: utf-8');
  // get service information
  $service = db_fetch_object(db_query("SELECT * FROM {rdfme_endpoint_services} WHERE name = '%s'", $name));
  
  if (!$service) { //if there was no service do nothing
  	//drupal_set_message(t('Error deleting the service (service not found in the RDFme database). Please, try again.'),'error');
  } else
  { //invoke the service
    if ($service->status != 1) //if service is disabled
    {
    	return drupal_not_found();
    }
    if ($service->type == 'sparqlscript')
    {
		$result =  rdfme_arc2_invoke_sparql_script($service->query);
		print ($result);
    }
    elseif ($service->type == 'sparql')
    {
    	$result = rdfme_arc2_invoke_sparql_query($service->query);
    	print ($result);
    }
  }
  exit();
}

/**
 * Change service status (enabled/ disabled)
 * @param operation name (enable, disable)
 * @param name of the service
 */
function rdfme_change_service_status($operation, $name) {
 	$status_operation = array('enable'=> 1, 'disable'=> 0);
  
    db_query("UPDATE {rdfme_endpoint_services} SET status='%s', last_update=NOW() WHERE name = '%s'", $status_operation[$operation], $name);
	drupal_set_message(t('The service "!name" has been !operationd.', array('!name' => $name, '!operation' => $operation)));

  	// Redirect to the rdfme module settings
  	drupal_goto('admin/settings/rdfme/endpoint/services');
}


/**
 * Delete service
 * @param id of the service to delete
 */
function rdfme_delete_service($id) {

  $service = db_fetch_object(db_query("SELECT * FROM {rdfme_endpoint_services} WHERE id = '%d'", $id));
  
  if (!$service) { //if there was no service in the database show error
  	drupal_set_message(t('Error deleting the service (service not found in the RDFme database). Please, try again.'),'error');
  } else
  {
	  $exe_query = db_query("DELETE FROM {rdfme_endpoint_services} WHERE id = '%d'", $id);
	  if ($exe_query != FALSE) {
	    drupal_set_message(t('Deleted service with id: !id', array('!id' => $id)));
	  }
	  else {
	    drupal_set_message(t('Error deleting the service (error deleting from RDFme database). Please, try again.'),'error');
	  }
  }
  // Redirect to the rdfme module settings
  drupal_goto('admin/settings/rdfme/endpoint/services');
}


/**
 * Delete all services
 */
function rdfme_delete_all_services() {
  // Datasets
  $exe_query = db_query("DELETE FROM {rdfme_endpoint_services}");
  if ($exe_query !== FALSE) {
  	rdfme_arc2_delete_all(); //clean triple store 
    drupal_set_message(t('Services deleted'));
  }
  else {
    drupal_set_message(t('Error deleting services. Please, try again.'));
  }
  // Redirect to the rdfme module settings
  drupal_goto('admin/settings/rdfme/endpoint/services');
}

/**
 * Edit service
 * @param name of the service to edit
 */
function rdfme_edit_service(&$form_state, $name) {

  $service = db_fetch_object(db_query("SELECT * FROM {rdfme_endpoint_services} WHERE name = '%s'", $name));

  if (!$service) { //if there was no service in the database show error
  	drupal_set_message(t('Error editing the service (service not found in the RDFme database). Please, try again.'),'error');
  } else
  {
  	  $service_type = array( 'sparql' => 0, 'sparqlscript' => 1);
	  $form['service_edit'] = array(
	    '#type' => 'fieldset',
	    '#title' => t('Edit new SPARQL Service'),
	    '#collapsible' => FALSE,
	    '#collapsed' => FALSE,
	    '#tree' => FALSE,
	    '#description' => t('RDFme allows to create custom services that operate on Endpoint data and are based on SPARQL and SPARQLScript functionality of the underlying ARC2 triple store. The services can retrieve or write data and return a certain response to the client. For example: get 10 last nodes of particular kind, get 10 last comments, get statistics of the drupal etc. If SPARQLScript is used the final result should be put into "rdfme_service" variable).',
	      array(
	        '!RDF' => l(t('RDF'), 'http://drupal.org/project/rdf'),
	        '!indexed' => l(t('indexed'), 'http://github.com/semsol/arc2'),
	        '!sparql' => l('SPARQL', 'http://www.w3.org/TR/rdf-sparql-query/'),
	        '!cron' => l('cron maintenance task', 'admin/reports/status'),
	      )
	    ),
	  );
	  $form['service_edit']['service_name'] = array(
	    '#type' => 'textfield',
	    '#title' => t('Service name'),
	    '#default_value' => $service->name, 
	    '#description' => t('Name used in the HTTP address of the service to access it.'),
	  );
	  $form['service_edit']['service_query'] = array(
	    '#type' => 'textarea',
		'#title' => t('Service query text'),
	    '#default_value' => $service->query, 
	    '#rows' => 30,
	    '#description' => t('Service query text is a script in SPARQL or SPARQLScript that operates on the datasets and returns some response to the client.', array('!reindex' => l('invoke update for entire index', 'admin/settings/rdfme/endpoint/reindex/all'))),
	  );
	  $sparql_filter_id = rdfme_check_sparql_code_editor();
	  if ($sparql_filter_id)
	  	$form['service_edit']['format'] = filter_form($sparql_filter_id, NULL, array('service_query_format'));
	    
	  $form['service_edit']['sparqlscript'] = array(
	    '#type' => 'checkbox',
	    '#description' => t('SPARQLScript is an extension to SPARQL that allows variables and simple operators like loops and conditional statements, much like scripting in relational databases. For details see SPARQLScript manual.'),
	    '#default_value' => $service_type[$service->type],
	    '#title' => t('SPARQLScript Service'),
	  );
	  $form['service_edit']['service_id'] = array(	
		'#type' => 'hidden', 
	  	'#value' => $service->id,
	  );
	  $form['service_edit']['submit'] = array(
	    '#type' => 'submit',
	    '#value' => 'Save Service',
	  ); 
  	  return $form;
  }
}

function theme_rdfme_edit_service($form) {
  return drupal_render($form);
}

/**
 * Function checks if "SPARQL" input filter is installed , if so then it returns the ID of the SPARQL code editor
 * (The sparql code input filter 
 */
function rdfme_check_sparql_code_editor() {
 static $formats;
 if (isset($formats)) {
 	foreach ($formats as $format)
 		if ($format->name == 'SPARQL') return $format->format;
 	return NULL;
 } else //if the formats variable is not cached access database to check if SPARQL format exists
 {
	$filter = db_fetch_object(db_query("SELECT * FROM {filter_formats} WHERE name='SPARQL'"));
	if (isset($filter)) {
		return $filter->format;
		
		}
	else
		return NULL;
 }
}

function rdfme_edit_service_submit($form, &$form_state) {
  if ($form_state['values']['service_name'] != '' &&  $form_state['values']['service_query'] != '') {
  	$service_type = "sparql";
  	if ($form_state['values']['sparqlscript'] == 1) $service_type = "sparqlscript";
    rdfme_update_service($form_state['values']['service_id'], $form_state['values']['service_name'], $form_state['values']['service_query'], $service_type);
  }
  else {
    drupal_set_message(t('Service name and query cannot be blank fields'));
  }
  // Redirect to the rdfme module settings
  $form_state['redirect'] = 'admin/settings/rdfme/endpoint/services';
}


/**
 * ***************          RDFme      	   ***************
 * *************** Generic SPARQL Endpoint ***************
 */

function rdfme_access_endpoint() {
	 //info message if no query is stated
	 $endpoint_info= "<br/>REST parameters summary:<br/>";
	 $endpoint_info.= "<ul>";
	 $endpoint_info.= "<li><b>query</b> - sparql query text</li>";
	 $endpoint_info.= "<li><b>output</b> - output format (available: htmltab, xml, json, plain, php_ser, turtle, rdfxml, infos, sql, tsv), Default: rdfxml</li>";
	 $endpoint_info.= "<li><b>jsonp</b> - if format is json, it is possible to specify the callback class name</li>";
	 $endpoint_info.= "</ul>";
	 $endpoint_info.= "<b>Example:</b> Get all information stored in the RDFme Endpoint (limit to 10 first triples) - <a href='".url('rdfme/endpoint/',array('query' => 'query='. "SELECT+*+WHERE+%7B%0D%0A++GRAPH+%3Fg+%7B+%3Fs+%3Fp+%3Fo+.+%7D%0D%0A%7D%0D%0ALIMIT+10&output=rdfxml"))."'>RDF/XML</a>";
	 $endpoint_info.= "<br/><br/>Please refer to <a href='https://github.com/semsol/arc2/wiki'>ARC2 endpoint documentation</a> for a full list of available parameters and more detailed information on the endpoint functions.";
	 //check if endpoint is on or off
	if (variable_get('rdfme_endpoint_sparql_status', 0) == 0) 
	{
	 $endpoint_off_info = "<br/>Endpoint service is: <b>Off</b>.";
	 $endpoint_off_info.= $endpoint_info;
	 return $endpoint_off_info;
	}
	$permissions_array = rdfme_access_endpoint_permissions_array(); //get user permissions for sparql endpoint
	if (isset($_GET['query']))
	{
	 if (!isset($_GET['output'])) $_GET['output'] = "rdfxml"; // if no output specified default is RDF/XML
	 //$result = rdfme_arc2_invoke_sparql_query($service->query);
	 $ep = rdfme_arc2_init_endpoint('endpoint',$permissions_array);	 
	 $ep->handleRequest();
	 $ep->sendHeaders();
	 $result = $ep->getResult();
	 print $result;
	 exit();
	} 
	 //if no query was specified display help information and endpoint status
	 $endpoint_on_info = "<br/>Endpoint service is: <b>On</b>.";
	 $endpoint_on_info.= "<br/>Your permissions are: ". implode(", ", $permissions_array)."<br/>";
	 $endpoint_on_info.= $endpoint_info;
	 return $endpoint_on_info;
}

function rdfme_access_endpoint_permissions_array() {
    $permissions_array = array();
	if (user_access('rdfme endpoint select')) $permissions_array[] = 'select';
	if (user_access('rdfme endpoint construct')) $permissions_array[] = 'construct';
	if (user_access('rdfme endpoint ask')) $permissions_array[] = 'ask';
	if (user_access('rdfme endpoint describe')) $permissions_array[] = 'describe';
	if (user_access('rdfme endpoint load')) $permissions_array[] = 'load';
	if (user_access('rdfme endpoint insert')) $permissions_array[] = 'insert';
	if (user_access('rdfme endpoint delete')) $permissions_array[] = 'delete';
	if (user_access('rdfme endpoint dump')) $permissions_array[] = 'dump';
	return $permissions_array;
}

/**
 * ***************           RDFme           ***************
 * *************** ARC 2 Endpoint operations ***************
 */
 
function rdfme_arc2_init_endpoint($type = 'store', $permissions_array = NULL, $ns = NULL) {
  global $db_url;

  $url = parse_url($db_url);
  
  if ($permissions_array == NULL) $permissions_array = array(
      'select', 'construct', 'ask', 'describe', 
      'load', 'insert', 'delete', 
      'dump' /* dump is a special command for streaming SPOG export */
    );
  $config = array(
    /* db */
    'db_host' => urldecode($url['host']),
    'db_name' => substr(urldecode($url['path']), 1),
    'db_user' => urldecode($url['user']),
    'db_pwd' => isset($url['pass']) ? urldecode($url['pass']) : '',
    /* store */
    'store_name' => 'rdfme_arc2',
  	'ns' => $ns,
    /* endpoint */
    'endpoint_features' => $permissions_array,
    'sparqlscript_default_endpoint' => 'local',
    'endpoint_timeout' => 60, /* not implemented in ARC2 preview */
   // 'endpoint_read_key' => '', /* optional */
   // 'endpoint_write_key' => 'somekey', /* optional */
   // 'endpoint_max_limit' => 500, /* optional */
  );
    
  /* instantiation */
  if ($type == 'endpoint') {
    $store = ARC2::getStoreEndpoint($config);
  	if (!$store->isSetUp()) {
    	$store->setUp();
  	}
  }
  elseif ($type == 'store' ) {
    $store = ARC2::getStore($config);
  	if (!$store->isSetUp()) {
    	$store->setUp();
  	}
  }
  elseif ($type == 'script_processor')
  {
   $store = ARC2::getSPARQLScriptProcessor($config);
  }

  return $store;
}

/*
 * Function used to index a dataset for the first time (skips optimalization for checking changes etc. just deletes all that was before and puts the data in)
 */
function rdfme_arc2_index_graph($url, $type) {
	
	// Instantiate the ARC2 local store.	
	$store = rdfme_arc2_init_endpoint('endpoint');
	$store->query('DELETE FROM <'.$url.'>'); //remove the previous version of the dataset (just in case some old data was in the endpoint)
	
	if ($type == 'local') //if indexing local data don't download RDF via http but directly access the database
	{
	//test local data loading directly from SQL database to ARC2 structures
	require_once drupal_get_path('module', 'rdfme') . '/includes/rdfme.export.inc';
	$triples = rdfme_dump_arc2();
	$store->insert($triples, $url); //load the updates into the triple store
	$store->optimizeTables(3); //optimize tables after load
	} else
	{
		$store->query('LOAD <'.$url.'> INTO <'.$url.'>'); //load new version into the store
		$store->optimizeTables(3); //optimize tables after load
	}
	
	if ($store->getErrors())
  		return FALSE;
  	else
  		return TRUE;
}

/*
 * Function updates an already existing graph with new triples
 */
function rdfme_arc2_update_graph($url, $type, $last_update) {
  // Instantiate the ARC2 local store.
  $store = rdfme_arc2_init_endpoint('endpoint');

  // Emtpy the local store.
  // FIXME optimize by doing this only when creating/saving a node.
//  $store->reset();

  // Fetch all the node id which are published.
  //$entities = db_query(db_rewrite_sql("SELECT nid FROM {node} WHERE status = 1 limit 1000"));
  //$query = ;
  //$store->query("LOAD <".$url."> INTO <".$url.">");
//  $doc = "http://localhost/~cyanide/ideastream_151_rdfme/?q=tordf";
//  $parser = ARC2::getRDFParser();
//  $parser->parse($doc);
//  $triples = $parser->getTriples();
//  $store->insert($triples, $doc);
	if ($type=='normal') { //regular update, delete all previous content of the dataset and reindex all
		$store->query('DELETE FROM <'.$url.'>'); //remove the previous version of the dataset (this is needed because some properties are not supposed to duplicate e.g. idea title)
		$store->query('LOAD <'.$url.'> INTO <'.$url.'>'); //load new version into the store
		$store->optimizeTables(3); //optimize tables after load
	} else if ($type=='local') { //if source is a the local rdfme dump get the changes directly via API (not with a HTTP service like with remote RDFme services)
	
  		$date_split = getdate(strtotime($last_update));
  				
		require_once drupal_get_path('module', 'rdfme') . '/includes/rdfme.export.inc';
		$triples = rdfme_dump_update_arc2($date_split['year'], $date_split['mon'], $date_split['mday'], $date_split['hours'], $date_split['minutes'], $date_split['seconds']);
		
		if (count($triples) > 0) //if the RDF was not empty add
		{
		 //delete all nodes/ comments or users that are in the updates and might also be in old version ARC2 (this is needed to avoid duplicates like idea with 2 titles)
		 $uri_list = array(); //list of node/comment/user uri's to delete 
		 $delete_query = "DELETE FROM <".$url."> {";
		 $current_uri="";
			for ($i = 0, $i_max = count($triples); $i < $i_max; $i++) {
			  $triple = $triples[$i];
			  if ($triple['s']!=$current_uri) {
			  	$current_uri = $triple['s'];
			  	$uri_list[] = $current_uri;
			  	$delete_query = $delete_query . " <".$current_uri."> ?p ?o .";
			  }
			}
			$delete_query = $delete_query. "}";
			
			$store->query($delete_query); //delete nodes that might duplicate
			$store->insert($triples, $url); //load the updates into the triple store
			$store->optimizeTables(3); //optimize tables after load
		}
  	} else if ($type=='rdfme') { //if source is rdfme invoke a special service that will return data modified/added only since the given date
  		//$date = ;
  		$date_split = getdate(strtotime($last_update));
  		$date_param =  "/".$date_split['year']. "/".$date_split['mon']."/".$date_split['mday']."/".$date_split['hours']."/".$date_split['minutes']."/".$date_split['seconds'];
  		
  		$rdfme_url = $url.$date_param;
		$parser = ARC2::getRDFParser();
		$parser->parse($rdfme_url);
		$triples = $parser->getTriples();
		if (count($triples) > 0) //if the RDF was not empty add
		{
		 //delete all nodes/ comments or users that are in the updates and might also be in old version ARC2 (this is needed to avoid duplicates like idea with 2 titles)
		 $uri_list = array(); //list of node/comment/user uri's to delete 
		 $delete_query = "DELETE FROM <".$url."> {";
		 $current_uri="";
			for ($i = 0, $i_max = count($triples); $i < $i_max; $i++) {
			  $triple = $triples[$i];
			  if ($triple['s']!=$current_uri) {
			  	$current_uri = $triple['s'];
			  	$uri_list[] = $current_uri;
			  	$delete_query = $delete_query . " <".$current_uri."> ?p ?o .";
			  }
			}
			$delete_query = $delete_query. "}";
			
			$store->query($delete_query); //delete nodes that might duplicate
			$store->insert($triples, $url); //load the updates into the triple store
			$store->optimizeTables(3); //optimize tables after load
		} 
  	} elseif ($type=='file') { // if source is a file check file modification date and don't update if the file has not changed
  	
		$curl = curl_init($url);
		
		//don't fetch the actual page, you only want headers
		curl_setopt($curl, CURLOPT_NOBODY, true);
		
		//stop it from outputting stuff to stdout
		curl_setopt($curl, CURLOPT_RETURNTRANSFER, true);
		
		// attempt to retrieve the modification date
		curl_setopt($curl, CURLOPT_FILETIME, true);
		
		$result = curl_exec($curl);
		
		if ($result === false) {
		    die (curl_error($curl)); 
		}
		
		$timestamp = curl_getinfo($curl, CURLINFO_FILETIME);
		if ($timestamp != -1) { //otherwise unknown
		    //update RDFme index only if the modification date is later than last update of index
		    if ($timestamp > strtotime($last_update))
		    {
				$store->query('DELETE FROM <'.$url.'>'); //remove the previous version of the dataset (this is needed because some properties are not supposed to duplicate e.g. idea title)
				$store->query('LOAD <'.$url.'> INTO <'.$url.'>'); //load new version into the store
				$store->optimizeTables(3); //optimize tables after load
		    }
		} else  //if modification date was not available fetch everything
		{
			$store->query('DELETE FROM <'.$url.'>'); //remove the previous version of the dataset (this is needed because some properties are not supposed to duplicate e.g. idea title)
			$store->query('LOAD <'.$url.'> INTO <'.$url.'>'); //load new version into the store
			$store->optimizeTables(3); //optimize tables after load
		}
  	}
  	
  	
	if ($store->getErrors())
  		return FALSE;
  	else
  		return TRUE;
  
  //$store->query('LOAD <http://localhost/~cyanide/etsit_ideas_en.rdf> INTO <http://gi2mo.org/test>');
/*
  while ($entity = db_fetch_object($entities)) {
    // Build the document path.
    $doc = url('node/' . $entity->nid . '/tordf', array('absolute' => TRUE));
    
    // Parse the document and insert it in the store.
    $parser = ARC2::getRDFParser();
    $parser->parse($doc);
    $triples = $parser->getTriples();
    $store->insert($triples, $doc);
    return;
  } */

//return t('The RDF index of the site has been rebuilt. Browse to the <a href="@endpoint">SPARQL endpoint</a> to query it.', array('@endpoint' => url('sparql_endpoint')));
}

/*
 * Function used to delete a selected dataset (graph) from the triple store
 */

function rdfme_arc2_delete_graph($url) {
  // Instantiate the ARC2 local store.
  $store = rdfme_arc2_init_endpoint('endpoint');
  $store->query('DELETE FROM <'.$url.'>'); //remove the previous version of the dataset (this is needed because some properties are not supposed to duplicate e.g. idea title)
  if ($store->getErrors())
  		return FALSE;
  	else
  		return TRUE;
}

/*
 * Function used to delete all content of the local triple store
 */
function rdfme_arc2_delete_all() {
  // Instantiate the ARC2 local store.
  $store = rdfme_arc2_init_endpoint('endpoint');
  $store->reset();
}

/*
 * Invoke a SPARQL query over the ARC2 triplestore
 */
function rdfme_arc2_invoke_sparql_query($query) {	
	//get namespaces from query
	$ptn = "@PREFIX[\s\n]+([^:]*)[^<]+.([^>]+)@";
	preg_match_all($ptn, $script, $matches); //
		
	$ns= array();
	if ($matches[1]!=NULL && $matches[2]!=NULL) //if any namespace prefixes and URIs were defined
	{
		foreach ($matches[1] as $key => $prefix)
			$ns[$prefix]= $matches[2][$key];
	}
	if (count($ns)>0)
		$store = rdfme_arc2_init_endpoint('endpoint',NULL, $ns); // Instantiate the ARC2 local store with default namespace prefixes
	else
		$store = rdfme_arc2_init_endpoint('endpoint'); // Instantiate the ARC2 local store.
	$store->handleQueryRequest($query);
	$result = $store->getResult();
	//$result = $store->query($query);

	if ($store->getErrors())
  		return NULL;
  	else
  		return $result;
}

/*
 * Invoke a SPARQLScript over the ARC2 triplestore
 */
function rdfme_arc2_invoke_sparql_script($script) {
	// Instantiate the ARC2 local store.
	$ssp = rdfme_arc2_init_endpoint('script_processor');
	$ssp->processScript($script);
	//get namespaces from query

	$ptn = "@PREFIX[\s\n]+([^:]*)[^<]+.([^>]+)@";
	preg_match_all($ptn, $script, $matches); //
		
	$ns= array();
	if ($matches[1]!=NULL && $matches[2]!=NULL) //if any namespace prefixes and URIs were defined
	{
		foreach ($matches[1] as $key => $prefix)
			$ns[$prefix]= $matches[2][$key];
	}
	
	//serialize to rdf
	$response = $ssp->toRDFXML($ssp->env['vars']['rdfme_service']['value'],$ns);

	if ($ssp->getErrors())
  		return FALSE;
  	else
  		return $response;
}

/**
 * ***************           RDFme           ***************
 * ***************  Endpoint API operations  ***************
 */
 
/**
 * Add dataset action
 * @param $dataset_url dataset Url address (can be an address of an RDF file or RDFme service
 * @param $dataset_name name of the dataset under which it is resolvable in RDFme
 * @param $dataset_type indexing type (normal - full reindexing in cron cycles, rdfme - updating only new changes, 
 *						local - local rdfme instance, connecting not via HTTP but internal API, file - regular RDF file, updating in cron cycles only if file has changed
 * @return 	1 = dataset added successfully, 
 *			2 = url already existed but updated name, 
 *			3 = dataset with the same data already exists , 
 *			0 = database/query error
 */
function rdfme_api_add_dataset($dataset_url, $dataset_name, $dataset_type) {
  
 $datasets = db_fetch_object(db_query("SELECT * FROM {rdfme_endpoint} WHERE url = '%s'", $dataset_url));

  if (!$datasets) {
    db_query("INSERT INTO {rdfme_endpoint} (name, url, type, last_update) VALUES ('%s', '%s', '%s', NOW())", $dataset_name, $dataset_url, $dataset_type);
    //add the triples to ARC2 store
	$result= rdfme_arc2_index_graph($dataset_url,$dataset_type);
	if ($result)
		return 1;
	else
		return 0; 
  }
  elseif ($datasets->name != $ns) {
    db_query("UPDATE {rdfme_endpoint} SET name = '%s' WHERE url = '%s'", $dataset_name, $dataset_url);
    return 2;
  }
  else {
    return 3;
  }
}

/**
 * Add service action
 * @param $service_name name of the service under which it is resolvable in RDFme, and accessible with REST interface
 * @param $service_query service query text
 * @param $service_type query language (sparql - regular sparql query, sparqlscript - enriched sparql with scripting elements like loops, conditions etc.)
 * @param $service_status enabled or disabled (1 = enabled, 0 = disabled)
 * @return 	1 = service added successfully, 
 *			0 = service already existed in the system
 */
function rdfme_api_add_service($service_name, $service_query, $service_type, $service_status) {
  
 $datasets = db_fetch_object(db_query("SELECT * FROM {rdfme_endpoint_services} WHERE name = '%s'", $service_name));

  if (!$datasets) {
    db_query("INSERT INTO {rdfme_endpoint_services} (name, url, query, type, last_update, status) VALUES ('%s', '%s', '%s', '%s', NOW(), %d)", $service_name, NULL, $service_query,$service_type,$service_status);
	return 1;
  }
  else {
    return 0;
  }
}