<?php
// $Id: views-view-table.tpl.php,v 1.8 2009/01/28 00:43:43 merlinofchaos Exp $
/**
 * @file views-view-table.tpl.php
 * Template to display a view as a table.
 *
 * - $title : The title of this group of rows.  May be empty.
 * - $header: An array of header labels keyed by field id.
 * - $fields: An array of CSS IDs to use for each field id.
 * - $class: A class or classes to apply to the table, based on settings.
 * - $row_classes: An array of classes to apply to each row, indexed by row
 *   number. This matches the index in $rows.
 * - $rows: An array of row items. Each row is an array of content.
 *   $rows are keyed by row number, fields within rows are keyed by field ID.
 * @ingroup views_templates
 */
?>
<table class="review_metrics_panel" border=0>
<tr>
<td class="review_metrics_panel_ratings">
<div id="reviews_list_review_summary">
<div class="reviews-section-title">Review Summary (ratings per type):</div>
<?php 
 	//get stats for all reviews from this idea

	$all_reviews_stats=array();	
	$result = db_query("SELECT MAX(field_review_rating_value) AS MAX, AVG (field_review_rating_value) AS AVG, COUNT(field_review_rating_value) AS COUNT from content_type_review JOIN node ON content_type_review.nid=node.nid WHERE field_review_rating_value IS NOT NULL AND field_reviewed_idea_nid=%d AND node.status=1 GROUP BY (field_reviewed_idea_nid)",arg(1));
	if ($data = db_fetch_object($result)) {
	   	$all_reviews_stats['MAX']=$data->MAX;
	   	$all_reviews_stats['AVG']=$data->AVG;
	   	$all_reviews_stats['COUNT']=$data->COUNT;
	}
		
 	//get stats for all reviews from this idea

	$reviews_stats_by_type=array();
	$result = db_query("SELECT AVG(field_review_rating_value) AS AVG, MAX(field_review_rating_value) AS MAX, COUNT(field_review_rating_value) AS COUNT, term_node.tid AS tid, term_data.name AS name,vocabulary.vid from content_type_review JOIN node ON content_type_review.nid=node.nid JOIN term_node on content_type_review.nid=term_node.nid JOIN term_data ON term_node.tid=term_data.tid JOIN vocabulary ON term_data.vid=vocabulary.vid WHERE field_review_rating_value IS NOT NULL AND vocabulary.name='Review Types' AND content_type_review.field_reviewed_idea_nid=%d AND node.status=1 GROUP BY term_data.name",arg(1));
	$i=0;
	while ($data = db_fetch_object($result)) {
	   	$reviews_stats_by_type[$i]['name']=$data->name;
		$reviews_stats_by_type[$i]['tid']=$data->tid;
		$reviews_stats_by_type[$i]['avg']=$data->AVG;
		$reviews_stats_by_type[$i]['max']=$data->MAX;
		$reviews_stats_by_type[$i]['count']=$data->COUNT;
		$i++;
	}
	
	
	print ("<div class='review_stats'><div class='review_stats_name_all'>All Reviews<div class='reviews_count'> (".$all_reviews_stats['COUNT']. ")</div></div> - <div class='metric_name'>avg: </div><div class='metric_value'>".(double)$all_reviews_stats['AVG']."</div> <div class='metric_name'>max: </div><div class='metric_value'>".$all_reviews_stats['MAX']. "</div></div>"); 
	foreach ($reviews_stats_by_type as $review_type_stats)
	{
	 print ("<div class='review_stats'><div class='review_stats_name'><a href='".url("taxonomy/term/".$review_type_stats['tid'])."'>".$review_type_stats['name']."</a></div><div class='reviews_count'> (".$review_type_stats['count'].")</div> - <div class='metric_name'>avg: </div><div class='metric_value'>".(double)$review_type_stats['avg']."</div> <div class='metric_name'>max: </div><div class='metric_value'>".$review_type_stats['max']."</div></div>"); 
	}
 
?>
</div>
</td>
<td class="review_metrics_panel_users">
<div id="reviews_list_user_metrics">
<div class="reviews-section-title">User Metrics:</div>
<?php 

	$comment_stats=array();	
	//sum of votes and total votes
	$result = db_query("SELECT SUM(votingapi_vote.value) AS vote_sum, COUNT(votingapi_vote.value) AS total_votes from votingapi_vote JOIN node ON votingapi_vote.content_id=node.nid where votingapi_vote.content_type = 'node' AND votingapi_vote.content_id=%d AND node.type='idea' GROUP BY (votingapi_vote.content_id)",arg(1));
	
	if ($data = db_fetch_object($result)) {
	   	$comment_stats['vote_sum']=$data->vote_sum;
	   	$comment_stats['total_votes']=$data->total_votes;
	} else 
	{
	$comment_stats['vote_sum']=0;
	$comment_stats['total_votes']=0;
	}
	//votes up
	$result = db_query("SELECT COUNT(votingapi_vote.value) AS votes_up from votingapi_vote JOIN node ON votingapi_vote.content_id=node.nid where votingapi_vote.content_type = 'node' AND votingapi_vote.content_id=%d AND node.type='idea' AND votingapi_vote.value>0 GROUP BY (votingapi_vote.content_id)",arg(1));
	
	if ($data = db_fetch_object($result)) {
	   	$comment_stats['votes_up']=$data->votes_up;
	} else $comment_stats['votes_up']=0;
	//votes down
	$result = db_query("SELECT COUNT(votingapi_vote.value) AS votes_down from votingapi_vote JOIN node ON votingapi_vote.content_id=node.nid where votingapi_vote.content_type = 'node' AND votingapi_vote.content_id=%d AND node.type='idea' AND votingapi_vote.value<0 GROUP BY (votingapi_vote.content_id)",arg(1));
	
	if ($data = db_fetch_object($result)) {
	   	$comment_stats['votes_down']=$data->votes_down;
	} else $comment_stats['votes_down']=0;
	//comment count & author count
	$result = db_query("SELECT COUNT(comments.cid) AS comment_count, COUNT(DISTINCT(comments.name)) AS author_count FROM comments JOIN node ON comments.nid=node.nid WHERE node.type='idea' AND node.nid=%d AND comments.status<>1 GROUP BY(comments.nid)",arg(1));
	
	if ($data = db_fetch_object($result)) {
	   	$comment_stats['comment_count']=$data->comment_count;
	   	$comment_stats['author_count']=$data->author_count;
	} else 
	{ 
	   	$comment_stats['comment_count']=0;
	   	$comment_stats['author_count']=0;
	}

	print ("<div class='review_stats'><div class='review_stats_name'>Votes<div class='reviews_count'> (".$comment_stats['total_votes']. ")</div></div> - <div class='metric_name'>sum: </div><div class='metric_value'>".$comment_stats['vote_sum']."</div> <div class='metric_name'>up: </div><div class='metric_value'>".$comment_stats['votes_up']. "</div> <div class='metric_name'>down: </div><div class='metric_value'>".$comment_stats['votes_down']. "</div></div>"); 
	
	print ("<div class='review_stats'><div class='review_stats_name'>Comments<div class='reviews_count'> (".$comment_stats['comment_count']. ")</div></div> - <div class='metric_name'>distinct authors: </div><div class='metric_value'>".$comment_stats['author_count']."</div></div>"); 

	
?>
</div>
</td>
</table>
<div class="reviews-section-title">Reviews List:</div>

<table class="<?php print $class; ?>">
  <?php if (!empty($title)) : ?>
    <caption><?php print $title; ?></caption>
  <?php endif; ?>
  <thead>
    <tr>
      <?php foreach ($header as $field => $label): ?>
        <th class="views-field views-field-<?php print $fields[$field]; ?>">
          <?php print $label; ?>
        </th>
      <?php endforeach; ?>
    </tr>
  </thead>
  <tbody>
    <?php foreach ($rows as $count => $row): ?>
      <tr class="<?php print implode(' ', $row_classes[$count]); ?>">
        <?php foreach ($row as $field => $content): ?>
          <td class="views-field views-field-<?php print $fields[$field]; ?>">
            <?php print $content; ?>
          </td>
        <?php endforeach; ?>
      </tr>
    <?php endforeach; ?>
  </tbody>
</table>